#ifndef INCLUDED_CUDA_HELPERS_H
#define INCLUDED_CUDA_HELPERS_H

#include "cuda_runtime.h"

#include <cstdint>

typedef std::uint32_t uint32_t;
typedef std::uint64_t uint64_t;

extern "C" uint32_t device_warpsize (void);

#define QWORD_SIZE              (4 * 4)
#define FRAMESIZE_BASE_MULTIPLE (QWORD_SIZE * device_warpsize())

extern "C" void bufferDiffLaunchVariablesQWord (const uint32_t qwordsize, uint32_t *const qwordsdown, dim3 *const blockcnt, uint32_t *const threadcnt, dim3 *const blockqwordsize, uint32_t *const threadqwordsize);

#endif // INCLUDED_CUDA_HELPERS_H
